unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls;

Var OldKeyboardState: TKeyboardState;

type
  //  
  TRegisterServiceProcess = function (dwProcessID, dwType:DWord) : DWORD; stdcall;
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Button3: TButton;
    Button4: TButton;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button5: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    TabSheet2: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    Button6: TButton;
    Label11: TLabel;
    Button8: TButton;
    Button7: TButton;
    Button9: TButton;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Button10: TButton;
    Button11: TButton;
    Timer1: TTimer;
    Label17: TLabel;
    Button12: TButton;
    Button13: TButton;
    Label18: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

//1) 
procedure TForm1.Button1Click(Sender: TObject);
var hNdl :THandle;// DLL
    R: TRegisterServiceProcess;//  
begin
if not(csDesigning in ComponentState) then //    Delphi IDE
  begin
  hNdl:=LoadLibrary('KERNEL32.DLL');// DLL
  R:=GetProcAddress(hNdl, 'RegisterServiceProcess');//   DLL
  R(GetCurrentProcessID, 1);// 
  FreeLibrary(hNdl);// DLL
  end;
Button2.Enabled:=true;
Button1.Enabled:=false;
end;

// 
procedure TForm1.Button2Click(Sender: TObject);
var hNdl :THandle;// DLL
    R: TRegisterServiceProcess;//  
begin
if not(csDesigning in ComponentState) then //    Delphi IDE
  begin
  hNdl:=LoadLibrary('KERNEL32.DLL');// DLL
  R:=GetProcAddress(hNdl, 'RegisterServiceProcess');//   DLL
  R(GetCurrentProcessID, 0);// 
  FreeLibrary(hNdl);// DLL
  end;
Button1.Enabled:=true;
Button2.Enabled:=false;
end;

//2)   Ctrl-Alt-Del, Alt-Tab, Ctrl-Esc
procedure TForm1.Button3Click(Sender: TObject);
begin
SystemParametersInfo(SPI_SCREENSAVERRUNNING,1,0,0);
Button4.Enabled:=true;
Button3.Enabled:=false;
end;

//   Ctrl-Alt-Del, Alt-Tab, Ctrl-Esc
procedure TForm1.Button4Click(Sender: TObject);
begin
SystemParametersInfo(SPI_SCREENSAVERRUNNING,0,0,0);
Button3.Enabled:=true;
Button4.Enabled:=false;
end;

//3)     
procedure TForm1.Button5Click(Sender: TObject);
Var Wnd:THandle;// 
begin
Wnd:=findWindow(0,PChar(Edit1.text));//   
if (Wnd<>0) then SetWindowText(Wnd,PChar(Edit2.text))//  
  else MessageBox(Application.handle,'  ','',MB_OK);
end;

//4),       Windows
procedure TForm1.Button6Click(Sender: TObject);
begin
Form2:=TForm2.Create(self);
Form2.Show;
end;

//5)   Num Lock
procedure TForm1.Button7Click(Sender: TObject);
Var KeyboardState: TKeyboardState; // -
begin
GetKeyboardState(KeyboardState); //  
//     144
KeyboardState[144]:=KeyboardState[144] xor 1;
SetKeyboardState(KeyboardState); //   
end;

//   Caps Lock
procedure TForm1.Button8Click(Sender: TObject);
Var KeyboardState: TKeyboardState; // -
begin
GetKeyboardState(KeyboardState); //  
//     20
KeyboardState[020]:=KeyboardState[020] xor 1;
SetKeyboardState(KeyboardState); //   
end;

//   Scroll Lock
procedure TForm1.Button9Click(Sender: TObject);
Var KeyboardState: TKeyboardState; // -
begin
GetKeyboardState(KeyboardState); //  
//     145
KeyboardState[145]:=KeyboardState[145] xor 1;
SetKeyboardState(KeyboardState); //   
end;

//6)   
procedure TForm1.Timer1Timer(Sender: TObject);
begin
//   Num Lock, Caps Lock  Scroll Lock
Button7.Click;
Button8.Click;
Button9.Click;
end;

//  
procedure TForm1.Button10Click(Sender: TObject);
begin
GetKeyboardState(OldKeyboardState); //  
/// 
Button11.Enabled:=true;
Button10.Enabled:=false;
Timer1.Enabled:=true; // 
end;

// 
procedure TForm1.Button11Click(Sender: TObject);
begin
Timer1.Enabled:=false; // 
/// 
Button11.Enabled:=false;
Button10.Enabled:=true;
SetKeyboardState(OldKeyboardState); //  
end;

//   
procedure TForm1.Button12Click(Sender: TObject);
Var Layout:array[0..KL_NAMELENGTH] of char; // 
begin
LoadKeyboardLayout(StrCopy(Layout,'00000419'),KLF_ACTIVATE);
end;

//   
procedure TForm1.Button13Click(Sender: TObject);
Var Layout:array[0..KL_NAMELENGTH] of char; // 
begin
LoadKeyboardLayout(StrCopy(Layout,'00000409'),KLF_ACTIVATE);
end;

end.
